# -*- coding: utf-8 -*-

#二点間の距離を表示
#ウィジェットに収録する場合はutfでコーディングする

#頂点を二点選択状態で実行すると、二点間の距離をメッセージウインドウに表示します。

#動作条件
#選択形状がポリゴンメッシュ
#編集モードに入っている
#頂点編集モード
#選択している頂点の数がちょうど二個


#上位パートに変換マトリクスがかかっていたり、ローカル座標に入っている場合は
#表示データがおかしくなります




dousasuru=0
error=0

#動作条件を満たしているか確認

if xshade.scene().is_modify_mode==True and xshade.scene().active_shape().type==7 and xshade.scene().selection_mode==2:
  if xshade.scene().active_shape().number_of_active_control_points==2:
    dousasuru=1
  else:
    error=1


if dousasuru==1:
  activepointlist=[]
  for i in range(xshade.scene().active_shape().total_number_of_control_points):
    if xshade.scene().active_shape().vertex(i).active==True:
      activepointlist.append(i)

  tempos=xshade.scene().active_shape().vertex(activepointlist[0]).position
  apos=[tempos[0],tempos[1],tempos[2]]  
  tempos=xshade.scene().active_shape().vertex(activepointlist[1]).position
  bpos=[tempos[0],tempos[1],tempos[2]]  

  #distが距離　distxがx座標のみの距離　distyがy座標のみの距離　distzがz座標のみの距離
  dist=pow( (apos[0]-bpos[0])**2+(apos[1]-bpos[1])**2+(apos[2]-bpos[2])**2,0.5)
  distx=apos[0]-bpos[0]
  if distx<0:distx=-1*distx
  disty=apos[1]-bpos[1]
  if disty<0:disty=-1*disty
  distz=apos[2]-bpos[2]
  if distz<0:distz=-1*distz

  #表示
  print '距離：'+str(dist)+'、x座標差：'+str(distx)+'、y座標差：'+str(disty)+'、z座標差：'+str(distz)


#選択頂点が二個以外の場合
if error==1:
  dialog=xshade.create_dialog()
  idx=dialog.append_push_button('頂点は二個のみ選択してください')
  dialog.ask('二頂点間の距離を表示')
  

